OGRE-Next: Ogre::ResourceManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
Ogre::ResourceManager Class Referenceabstract
Core » Resources

Defines a generic resource handler. More...

`#include <OgreResourceManager.h>`

Inheritance diagram for Ogre::ResourceManager:
[legend]

## Classes
class | ResourcePool
| Definition of a pool of resources, which users can use to reuse similar resources many times without destroying and recreating them. More...

## Public Types
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap

## Public Member Functions
| ResourceManager ()
| ~ResourceManager () override
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder () const override
| Gets the relative loading order of resources of this type.
virtual size_t | getMemoryBudget () const
| Get the limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryUsage () const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator ()
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType () const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns () const override
| Gets the file patterns which should be used to find scripts for this ResourceManager.
virtual bool | getVerbose ()
| Gets whether this manager and its resources habitually produce log output.
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse the definition of a set of resources from a script file.
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
virtual void | remove (const ResourcePtr &r)
| Remove a single resource.
virtual void | remove (const String &name)
| Remove a single resource by name.
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle.
virtual void | removeAll ()
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager.
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager.
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
virtual void | unload (const String &name)
| Unloads a single resource by name.
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()

## Public Attributes
| OGRE_AUTO_MUTEX

## Detailed Description

Defines a generic resource handler.

Remarks
  A resource manager is responsible for managing a pool of resources of a particular type. It must index them, look them up, load and destroy them. It may also need to stay within a defined memory budget, and temporarily unload some resources if it needs to to stay within this budget.

  Resource managers use a priority system to determine what can be unloaded, and a Least Recently Used (LRU) policy within resources of the same priority.

  Resources can be loaded using the generalised load interface, and they can be unloaded and removed. In addition, each subclass of ResourceManager will likely define custom 'load' methods which take explicit parameters depending on the kind of resource being created.

Note
  Resources can be loaded and unloaded through the Resource class, but they can only be removed (and thus eventually destroyed) using their parent ResourceManager.
  If OGRE_THREAD_SUPPORT is 1, this class is thread-safe.

## Member Typedef Documentation

## ◆ ResourceCreateOrRetrieveResult

typedef std::pair<ResourcePtr, bool> Ogre::ResourceManager::ResourceCreateOrRetrieveResult

## ◆ ResourceHandleMap

typedef map<ResourceHandle,ResourcePtr>::type Ogre::ResourceManager::ResourceHandleMap

## ◆ ResourceMap

typedef unordered_map<String,ResourcePtr>::type Ogre::ResourceManager::ResourceMap

## ◆ ResourceMapIterator

typedef MapIterator<ResourceHandleMap> Ogre::ResourceManager::ResourceMapIterator

## ◆ ResourceWithGroupMap

typedef unordered_map<String,ResourceMap>::type Ogre::ResourceManager::ResourceWithGroupMap

## Constructor & Destructor Documentation

## ◆ ResourceManager()

Ogre::ResourceManager::ResourceManager | ( |  | ) |

## ◆ ~ResourceManager()

Ogre::ResourceManager::~ResourceManager | ( |  | ) |
| override

## Member Function Documentation

## ◆ _notifyResourceLoaded()

virtual void Ogre::ResourceManager::_notifyResourceLoaded | ( | Resource * | res | ) |
| virtual

Notify this manager that a resource which it manages has been loaded.

## ◆ _notifyResourceTouched()

virtual void Ogre::ResourceManager::_notifyResourceTouched | ( | Resource * | res | ) |
| virtual

Notify this manager that a resource which it manages has been 'touched', i.e.

used.

## ◆ _notifyResourceUnloaded()

virtual void Ogre::ResourceManager::_notifyResourceUnloaded | ( | Resource * | res | ) |
| virtual

Notify this manager that a resource which it manages has been unloaded.

## ◆ createOrRetrieve()

virtual ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )
| virtual

Create a new resource, or retrieve an existing one with the same name if it already exists.

Remarks
  This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

See also
  ResourceManager::createResource
  ResourceManager::getResourceByName

Returns
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

## ◆ createResource()

virtual ResourcePtr Ogre::ResourceManager::createResource | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )
| virtual

Creates a new blank resource, but does not immediately load it.

Remarks
  Resource managers handle disparate types of resources, so if you want to get at the detailed interface of this resource, you'll have to cast the result to the subclass you know you're creating.

Parameters

  name | The unique name of the resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

## ◆ destroyAllResourcePools()

void Ogre::ResourceManager::destroyAllResourcePools | ( |  | ) |

destroy all pools

## ◆ destroyResourcePool() [1/2]

void Ogre::ResourceManager::destroyResourcePool | ( | const String & | name | ) |

Destroy a resource pool.

## ◆ destroyResourcePool() [2/2]

void Ogre::ResourceManager::destroyResourcePool | ( | ResourcePool * | pool | ) |

Destroy a resource pool.

## ◆ getByHandle()

virtual ResourcePtr Ogre::ResourceManager::getByHandle | ( | ResourceHandle | handle | ) |
| virtual

Retrieves a pointer to a resource by handle, or null if the resource does not exist.

Referenced by resourceExists().

## ◆ getLoadingOrder()

Real Ogre::ResourceManager::getLoadingOrder | ( |  | ) | const
| inlineoverridevirtual

Gets the relative loading order of resources of this type.

Remarks
  There are dependencies between some kinds of resource in terms of loading order, and this value enumerates that. Higher values load later during bulk loading tasks.

Implements Ogre::ScriptLoader.

## ◆ getMemoryBudget()

virtual size_t Ogre::ResourceManager::getMemoryBudget | ( |  | ) | const
| virtual

Get the limit on the amount of memory this resource handler may use.

## ◆ getMemoryUsage()

virtual size_t Ogre::ResourceManager::getMemoryUsage | ( |  | ) | const
| inlinevirtual

Gets the current memory usage, in bytes.

## ◆ getResourceByName()

virtual ResourcePtr Ogre::ResourceManager::getResourceByName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )
| virtual

Retrieves a pointer to a resource by name, or null if the resource does not exist.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

Referenced by resourceExists().

## ◆ getResourceIterator()

ResourceMapIterator Ogre::ResourceManager::getResourceIterator | ( |  | ) |
| inline

Returns an iterator over all resources in this manager.

Note
  Use of this iterator is NOT thread safe!

## ◆ getResourcePool()

ResourcePool * Ogre::ResourceManager::getResourcePool | ( | const String & | name | ) |

Create a resource pool, or reuse one that already exists.

## ◆ getResourceType()

const String & Ogre::ResourceManager::getResourceType | ( |  | ) | const
| inline

Gets a string identifying the type of resource this manager handles.

## ◆ getScriptPatterns()

const StringVector & Ogre::ResourceManager::getScriptPatterns | ( |  | ) | const
| inlineoverridevirtual

Gets the file patterns which should be used to find scripts for this ResourceManager.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

  This method lets you determine the file pattern which will be used to identify scripts intended for this manager.

Returns
  A list of file patterns, in the order they should be searched in.

See also
  isScriptingSupported, parseScript

Implements Ogre::ScriptLoader.

## ◆ getVerbose()

virtual bool Ogre::ResourceManager::getVerbose | ( |  | ) |
| inlinevirtual

Gets whether this manager and its resources habitually produce log output.

## ◆ load()

virtual ResourcePtr Ogre::ResourceManager::load | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | loadParams = 0,
|  | bool | backgroundThread = false )
| virtual

Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ parseScript()

void Ogre::ResourceManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName )
| inlineoverridevirtual

Parse the definition of a set of resources from a script file.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

Parameters

  stream | Weak reference to a data stream which is the source of the script
  groupName | The name of the resource group that resources which are parsed are to become a member of. If this group is loaded or unloaded, then the resources discovered in this script will be loaded / unloaded with it.

Implements Ogre::ScriptLoader.

## ◆ prepare()

virtual ResourcePtr Ogre::ResourceManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | loadParams = 0,
|  | bool | backgroundThread = false )
| virtual

Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ reloadAll() [1/2]

void Ogre::ResourceManager::reloadAll | ( | bool | reloadableOnly = true | ) |
| inline

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  reloadableOnly | If true (the default), only reload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't loaded again. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, Ogre::Resource::LF_INCLUDE_NON_RELOADABLE, and reloadAll().

Referenced by reloadAll(), and reloadUnreferencedResources().

## ◆ reloadAll() [2/2]

virtual void Ogre::ResourceManager::reloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtual

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources. Additionally, reloading could be done with preserving some selected resource states that could be used elsewhere.

See also
  Resource::LoadingFlags for additional information.

## ◆ reloadUnreferencedResources()

void Ogre::ResourceManager::reloadUnreferencedResources | ( | bool | reloadableOnly = true | ) |
| inline

Caused all currently loaded but not referenced by any other object resources to be reloaded.

Remarks
  This method behaves like reloadAll, except that it only reloads resources which are not in use, i.e. not referenced by other objects.

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of reloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only reloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE, and reloadAll().

## ◆ remove() [1/3]

virtual void Ogre::ResourceManager::remove | ( | const ResourcePtr & | r | ) |
| virtual

Remove a single resource.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [2/3]

virtual void Ogre::ResourceManager::remove | ( | const String & | name | ) |
| virtual

Remove a single resource by name.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [3/3]

virtual void Ogre::ResourceManager::remove | ( | ResourceHandle | handle | ) |
| virtual

Remove a single resource by handle.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeAll()

virtual void Ogre::ResourceManager::removeAll | ( |  | ) |
| virtual

Removes all resources.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to these resources, they will persist until they have been finished with; however to all intents and purposes the resources no longer exist and will get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeUnreferencedResources()

virtual void Ogre::ResourceManager::removeUnreferencedResources | ( | bool | reloadableOnly = true | ) |
| virtual

Remove all resources which are not referenced by any other object.

Remarks
  This method behaves like removeAll, except that it only removes resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, remove or reload that resource will cause dangerous pointer access. Use this function instead of removeAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only removes resources which can be subsequently automatically reloaded.

## ◆ resourceExists() [1/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | const String & | name | ) |
| inlinevirtual

Returns whether the named resource exists in this manager.

References getResourceByName().

## ◆ resourceExists() [2/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | ResourceHandle | handle | ) |
| inlinevirtual

Returns whether a resource with the given handle exists in this manager.

References getByHandle().

## ◆ setMemoryBudget()

virtual void Ogre::ResourceManager::setMemoryBudget | ( | size_t | bytes | ) |
| virtual

Set a limit on the amount of memory this resource handler may use.

Remarks
  If, when asked to load a new resource, the manager believes it will exceed this memory budget, it will temporarily unload a resource to make room for the new one. This unloading is not permanent and the Resource is not destroyed; it simply needs to be reloaded when next used.

## ◆ setVerbose()

virtual void Ogre::ResourceManager::setVerbose | ( | bool | v | ) |
| inlinevirtual

Sets whether this manager and its resources habitually produce log output.

## ◆ unload() [1/2]

virtual void Ogre::ResourceManager::unload | ( | const String & | name | ) |
| virtual

Unloads a single resource by name.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unload() [2/2]

virtual void Ogre::ResourceManager::unload | ( | ResourceHandle | handle | ) |
| virtual

Unloads a single resource by handle.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unloadAll() [1/2]

void Ogre::ResourceManager::unloadAll | ( | bool | reloadableOnly = true | ) |
| inline

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  reloadableOnly | If true (the default), only unload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't load them later. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, Ogre::Resource::LF_INCLUDE_NON_RELOADABLE, and unloadAll().

Referenced by unloadAll(), and unloadUnreferencedResources().

## ◆ unloadAll() [2/2]

virtual void Ogre::ResourceManager::unloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtual

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources.

See also
  Resource::LoadingFlags for additional information.

## ◆ unloadUnreferencedResources()

void Ogre::ResourceManager::unloadUnreferencedResources | ( | bool | reloadableOnly = true | ) |
| inline

Unload all resources which are not referenced by any other object.

Remarks
  This method behaves like unloadAll, except that it only unloads resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of unloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only unloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE, and unloadAll().

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::ResourceManager::OGRE_AUTO_MUTEX

The documentation for this class was generated from the following file:

- OgreResourceManager.h